/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * CadastroAlunos.java
 *
 * Created on 03/12/2010, 09:24:17
 */
package GUI;

import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;
import util.bd.ConexaoBD;

/**
 *
 * @author aluno
 */
public class CadastroMatriculas extends javax.swing.JDialog {

    private ConexaoBD conexao;
    private String listaExcluir = "0";
    private int leSize = 0;

    /** Creates new form CadastroAlunos */
    public CadastroMatriculas(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setLocationRelativeTo(parent);

        conexao = new ConexaoBD();

        ArrayList<util.bd.ListaDeMatriculas> alm = conexao.listarMatriculas();

        DefaultTableModel modelo = (DefaultTableModel) jTListaDeMatriculas.getModel();
        int a = modelo.getRowCount();
        for (int i = 0; i < a; i++) {
            modelo.removeRow(0);
        }

        for (util.bd.ListaDeMatriculas matricula : alm) {
            String vetor[] = new String[5];


            vetor[0] = Long.toString(matricula.getmID());
            vetor[1] = matricula.getNomeAluno();
            vetor[2] = Long.toString(matricula.gettID());
            vetor[3] = matricula.getNomeDisciplina().toString();
            vetor[4] = matricula.getNomeProfessor().toString();

            //adicionando na tabela
            modelo.addRow(vetor);
        }

        ArrayList<util.bd.ListaDeAlunos> ala = conexao.listarAlunos();

        jCBAluno.removeAllItems();
        jCBAluno.addItem("[ALUNO]");
        for (util.bd.ListaDeAlunos aluno : ala) {
            jCBAluno.addItem(aluno.getNomeAluno());
        }

        ArrayList<util.bd.ListaDeTurmas> alt = conexao.listarTurmas();

        jCBTurma.removeAllItems();
        jCBTurma.addItem("[TURMA]");
        for (util.bd.ListaDeTurmas turma : alt) {
            jCBTurma.addItem(turma.gettID() + " - " + turma.getNomeDisciplina() + " - " + turma.getNomeProfessor());
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jBAdicionar = new javax.swing.JButton();
        jBRemover = new javax.swing.JButton();
        jBAplicar = new javax.swing.JButton();
        jCBAluno = new javax.swing.JComboBox();
        jCBTurma = new javax.swing.JComboBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTListaDeMatriculas = new javax.swing.JTable();
        jLAviso = new javax.swing.JLabel();
        jBCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setResizable(false);

        jBAdicionar.setText("Adicionar");
        jBAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAdicionarActionPerformed(evt);
            }
        });

        jBRemover.setText("Remover");
        jBRemover.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBRemoverActionPerformed(evt);
            }
        });

        jBAplicar.setText("Aplicar");
        jBAplicar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAplicarActionPerformed(evt);
            }
        });

        jCBAluno.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "[ALUNO]" }));
        jCBAluno.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCBAlunoActionPerformed(evt);
            }
        });

        jCBTurma.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "[TURMA]" }));

        jTListaDeMatriculas.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Numero de Matricula", "Aluno", "Numero de Turma", "Disciplina", "Professor"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTListaDeMatriculas);

        jLAviso.setForeground(new java.awt.Color(255, 0, 0));

        jBCancelar.setText("Cancelar");
        jBCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jBCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBAplicar, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jCBAluno, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jCBTurma, 0, 208, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBAdicionar, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBRemover, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLAviso, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBAdicionar)
                    .addComponent(jBRemover)
                    .addComponent(jCBAluno, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCBTurma, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLAviso)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 21, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 228, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBAplicar)
                    .addComponent(jBCancelar))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jCBAlunoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCBAlunoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCBAlunoActionPerformed

    private void jBAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAdicionarActionPerformed
        String aluno = jCBAluno.getSelectedItem().toString();
        String turma = jCBTurma.getSelectedItem().toString();
        if ((aluno.equals("[ALUNO]")) || (turma.equals("[TURMA]"))) {

            jLAviso.setText("Escolha um(a) Aluno/Turma");

        } else {
            DefaultTableModel modelo = (DefaultTableModel) jTListaDeMatriculas.getModel();

            String vetor[] = new String[5];
            String split[] = turma.split(" - ");
            vetor[0] = " - ";
            vetor[1] = aluno;
            vetor[2] = split[0];
            vetor[3] = split[1];
            vetor[4] = split[2];

            modelo.addRow(vetor);
        }
    }//GEN-LAST:event_jBAdicionarActionPerformed

    private void jBRemoverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBRemoverActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTListaDeMatriculas.getModel();
        int r = jTListaDeMatriculas.getSelectedRow();
        if (r < 0){} else {
        if (modelo.getValueAt(r, 0).toString().equals(" - ")) {
        } else {
            listaExcluir = (listaExcluir + "," + modelo.getValueAt(r, 0).toString());
            leSize++;
        }
        modelo.removeRow(r);
        jLAviso.setText("");
        }
    }//GEN-LAST:event_jBRemoverActionPerformed

    private void jBAplicarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAplicarActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTListaDeMatriculas.getModel();
        int a = modelo.getRowCount();
        String aNome = "";
        int tID = 0;

        ArrayList<util.bd.ListaDeMatriculas> alm = conexao.listarMatriculas();

        for (int i = 0; i < a; i++) {
            String mID = modelo.getValueAt(i, 0).toString();
            if (mID.equals(" - ")) {
                aNome = modelo.getValueAt(i, 1).toString();
                tID = Integer.parseInt(modelo.getValueAt(i, 2).toString());
                conexao.adicionarMatricula(aNome, tID);
            }
        }
        if (leSize > 0) {
            String[] le = listaExcluir.split(",");
            for (int i = 1; i < leSize + 1; i++) {
                conexao.removerMatricula(Integer.parseInt(le[i]));
            }
        }
        setVisible(false);
        dispose();
    }//GEN-LAST:event_jBAplicarActionPerformed

    private void jBCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCancelarActionPerformed
        setVisible(false);
        dispose();
}//GEN-LAST:event_jBCancelarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                CadastroMatriculas dialog = new CadastroMatriculas(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBAdicionar;
    private javax.swing.JButton jBAplicar;
    private javax.swing.JButton jBCancelar;
    private javax.swing.JButton jBRemover;
    private javax.swing.JComboBox jCBAluno;
    private javax.swing.JComboBox jCBTurma;
    private javax.swing.JLabel jLAviso;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTListaDeMatriculas;
    // End of variables declaration//GEN-END:variables
}
