/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * CadastroAlunos.java
 *
 * Created on 03/12/2010, 09:24:17
 */
package GUI;

import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;
import util.bd.ConexaoBD;

/**
 *
 * @author aluno
 */
public class CadastroTurmas extends javax.swing.JDialog {

    private ConexaoBD conexao;
    private String listaExcluir = "0";
    private int leSize = 0;

    /** Creates new form CadastroAlunos */
    public CadastroTurmas(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setLocationRelativeTo(parent);

        conexao = new ConexaoBD();

        ArrayList<util.bd.ListaDeTurmas> alm = conexao.listarTurmas();

        DefaultTableModel modelo = (DefaultTableModel) jTListaDeTurmas.getModel();
        int a = modelo.getRowCount();
        for (int i = 0; i < a; i++) {
            modelo.removeRow(0);
        }

        for (util.bd.ListaDeTurmas matricula : alm) {
            String vetor[] = new String[5];


            vetor[0] = Long.toString(matricula.gettID());
            vetor[1] = matricula.getNomeDisciplina().toString();
            vetor[2] = matricula.getNomeProfessor().toString();

            //adicionando na tabela
            modelo.addRow(vetor);
        }

        ArrayList<util.bd.ListaDeDisciplinas> ald = conexao.listarDisciplinas();

        jCBDisciplina.removeAllItems();
        jCBDisciplina.addItem("[DISCIPLINA]");
        for (util.bd.ListaDeDisciplinas disciplina : ald) {
            jCBDisciplina.addItem(disciplina.getNomeDisciplina());
        }

        ArrayList<util.bd.ListaDeProfessores> alp = conexao.listarProfessores();

        jCBProfessor.removeAllItems();
        jCBProfessor.addItem("[PROFESSOR]");
        for (util.bd.ListaDeProfessores professor : alp) {
            jCBProfessor.addItem(professor.getNomeProfessor());
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jBAdicionar = new javax.swing.JButton();
        jBRemover = new javax.swing.JButton();
        jBAplicar = new javax.swing.JButton();
        jCBDisciplina = new javax.swing.JComboBox();
        jCBProfessor = new javax.swing.JComboBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTListaDeTurmas = new javax.swing.JTable();
        jLAviso = new javax.swing.JLabel();
        jBCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setResizable(false);

        jBAdicionar.setText("Adicionar");
        jBAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAdicionarActionPerformed(evt);
            }
        });

        jBRemover.setText("Remover");
        jBRemover.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBRemoverActionPerformed(evt);
            }
        });

        jBAplicar.setText("Aplicar");
        jBAplicar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAplicarActionPerformed(evt);
            }
        });

        jCBDisciplina.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "[DISCIPLINA]" }));
        jCBDisciplina.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCBDisciplinaActionPerformed(evt);
            }
        });

        jCBProfessor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "[PROFESSOR]" }));

        jTListaDeTurmas.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Numero de Turma", "Disciplina", "Professor"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTListaDeTurmas);

        jLAviso.setForeground(new java.awt.Color(255, 0, 0));

        jBCancelar.setText("Cancelar");
        jBCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 526, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jCBDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jCBProfessor, 0, 208, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBAdicionar, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBRemover, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLAviso, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jBCancelar, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jBAplicar, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBAdicionar)
                    .addComponent(jBRemover)
                    .addComponent(jCBDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCBProfessor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLAviso)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 21, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 228, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBAplicar)
                    .addComponent(jBCancelar))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jCBDisciplinaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCBDisciplinaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCBDisciplinaActionPerformed

    private void jBAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAdicionarActionPerformed
        String disciplina = jCBDisciplina.getSelectedItem().toString();
        String professor = jCBProfessor.getSelectedItem().toString();
        if ((disciplina.equals("[DISCIPLINA]")) || (professor.equals("[PROFESSOR]"))) {

            jLAviso.setText("Escolha um(a) Disciplina/Professor");

        } else {
            DefaultTableModel modelo = (DefaultTableModel) jTListaDeTurmas.getModel();

            String vetor[] = new String[5];
            vetor[0] = " - ";
            vetor[1] = disciplina;
            vetor[2] = professor;

            modelo.addRow(vetor);
        }
    }//GEN-LAST:event_jBAdicionarActionPerformed

    private void jBRemoverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBRemoverActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTListaDeTurmas.getModel();
        int r = jTListaDeTurmas.getSelectedRow();
        if (r < 0){} else {
        if (modelo.getValueAt(r, 0).toString().equals(" - ")) {
        } else {
            listaExcluir = (listaExcluir + "," + modelo.getValueAt(r, 0).toString());
            leSize++;
        }
        modelo.removeRow(r);
        jLAviso.setText("");
        }
    }//GEN-LAST:event_jBRemoverActionPerformed

    private void jBAplicarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAplicarActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTListaDeTurmas.getModel();
        int a = modelo.getRowCount();
        String dNome = "";
        String pNome = "";

        ArrayList<util.bd.ListaDeTurmas> alt = conexao.listarTurmas();

        for (int i = 0; i < a; i++) {
            String mID = modelo.getValueAt(i, 0).toString();
            if (mID.equals(" - ")) {
                dNome = modelo.getValueAt(i, 1).toString();
                pNome = modelo.getValueAt(i, 2).toString();
                conexao.adicionarTurma(dNome, pNome);
            }
        }
        if (leSize > 0) {
            String[] le = listaExcluir.split(",");
            for (int i = 1; i < leSize + 1; i++) {
                conexao.removerTurma(Integer.parseInt(le[i]));
            }
        }

        setVisible(false);
        dispose();
    }//GEN-LAST:event_jBAplicarActionPerformed

    private void jBCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBCancelarActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_jBCancelarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                CadastroTurmas dialog = new CadastroTurmas(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBAdicionar;
    private javax.swing.JButton jBAplicar;
    private javax.swing.JButton jBCancelar;
    private javax.swing.JButton jBRemover;
    private javax.swing.JComboBox jCBDisciplina;
    private javax.swing.JComboBox jCBProfessor;
    private javax.swing.JLabel jLAviso;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTListaDeTurmas;
    // End of variables declaration//GEN-END:variables
}
